/* FF, GG, HH, and II transformations for rounds 1, 2, 3, and 4.
Rotation is separate from addition to prevent recomputation.
 */
static inline void FF(int16_t *state, int16_t a, int16_t b, int16_t c,int16_t d,int16_t x,int16_t s,int16_t ac) {
 state[a] += F (state[b], state[c], state[d]) + (x) + (ac); 
 state[a] = ROTATE_LEFT (state[a], (s)); 
 state[a] += state[b]; 
}

static inline void GG(int16_t *state, int16_t a, int16_t b, int16_t c,int16_t d,int16_t x,int16_t s,int16_t ac) {
 state[a] += G (state[b], state[c], state[d]) + (x) + (ac); 
 state[a] = ROTATE_LEFT (state[a], (s)); 
 state[a] += state[b]; 
}

static inline void HH(int16_t *state, int16_t a, int16_t b, int16_t c,int16_t d,int16_t x,int16_t s,int16_t ac) {
 state[a] += H (state[b], state[c], state[d]) + (x) + (ac); 
 state[a] = ROTATE_LEFT (state[a], (s)); 
 state[a] += state[b]; 
}

static inline void II(int16_t *state, int16_t a, int16_t b, int16_t c,int16_t d,int16_t x,int16_t s,int16_t ac) {
 state[a] += I (state[b], state[c], state[d]) + (x) + (ac); 
 state[a] = ROTATE_LEFT (state[a], (s)); 
 state[a] += state[b]; 
}
