#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <util/delay.h>

#define bit_set(port,bit)       { port |= (1<<(bit));}
#define bit_clear(port,bit)     { port &= ~(1<<(bit));}
#define min(a,b)                ((a)<(b) ? (a):(b))

#define nop()   __asm__ volatile ("nop" )
#define wdr()   __asm__ volatile("wdr" )
#define sleep()   __asm__ volatile("sleep" )

extern void shuffle_init(int16_t *);
extern void shuffle(int16_t *);
int main() {
	int8_t i;
	int16_t state[9];

	sei();

	shuffle_init(state);

	for (i=0; i< LOOP_COUNT ; i++) { 
		shuffle(state);
		nop();
	}
 	sleep();
	return 0;
}
